package io.modules.sys.controller;


import io.common.constant.Constant;
import io.common.page.PageData;
import io.common.utils.Result;
import io.common.validator.AssertUtils;
import io.common.validator.ValidatorUtils;
import io.common.validator.group.AddGroup;
import io.common.validator.group.DefaultGroup;
import io.common.validator.group.UpdateGroup;
import io.modules.item.dto.CertificatesDTO;
import io.modules.item.dto.UserDTO;
import io.modules.item.entity.SetResponse;
import io.modules.item.service.CertificatesService;
import io.modules.item.service.FrontUserService;
import io.modules.item.service.SetRequestService;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.Parameter;
import io.swagger.v3.oas.annotations.Parameters;
import io.swagger.v3.oas.annotations.enums.ParameterIn;
import io.swagger.v3.oas.annotations.tags.Tag;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.*;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * 证书表
 */
@RestController
@RequestMapping("/sys/certificate")
@Tag(name="证书表")
@CrossOrigin
public class CertificatesController {
    @Autowired
    private CertificatesService certificatesService;
    @Autowired
    private SetRequestService setRequestService;
    @Autowired
    private FrontUserService userService;
    @Value("${upload.url}")
    private  String uploadUrl;

    @GetMapping("page")
    @Operation(summary = "分页")
    @Parameters({
        @Parameter(name = Constant.PAGE, description = "当前页码，从1开始", in = ParameterIn.QUERY, required = true, ref="int") ,
        @Parameter(name = Constant.LIMIT, description = "每页显示记录数", in = ParameterIn.QUERY,required = true, ref="int") ,
        @Parameter(name = Constant.ORDER_FIELD, description = "排序字段", in = ParameterIn.QUERY, ref="String") ,
        @Parameter(name = Constant.ORDER, description = "排序方式，可选值(asc、desc)", in = ParameterIn.QUERY, ref="String")
    })
    public Result<PageData<CertificatesDTO>> page(@Parameter(hidden = true) @RequestParam Map<String, Object> params){
        PageData<CertificatesDTO> page = certificatesService.page(params);
        List<CertificatesDTO> collect = page.getList().stream().map(e -> {
            // 拼接域名
            e.setImg(uploadUrl + e.getImg());
            Long userId = e.getUserId();
            UserDTO userDTO = userService.get(userId);
            e.setUser(userDTO);
            return e;  // 返回修改后的对象
        }).collect(Collectors.toList());
        page.setList(collect);
        return new Result<PageData<CertificatesDTO>>().ok(page);
    }

    @PostMapping
    @Operation(summary = "保存")
    public Result save(@RequestBody CertificatesDTO dto){
        //效验数据
        ValidatorUtils.validateEntity(dto, AddGroup.class, DefaultGroup.class);
        dto.setImg(dto.getImg().replace(uploadUrl,""));
        certificatesService.save(dto);
        return new Result();
    }

    @PutMapping
    @Operation(summary = "修改")
    public Result update(@RequestBody CertificatesDTO dto){
        //效验数据
        ValidatorUtils.validateEntity(dto, UpdateGroup.class, DefaultGroup.class);
        dto.setImg(dto.getImg().replace(uploadUrl,""));
        certificatesService.update(dto);
        return new Result();
    }

    @PutMapping("block")
    @Operation(summary = "上链")
    public Result book(@RequestBody CertificatesDTO dto){
        //效验数据
        ValidatorUtils.validateEntity(dto, UpdateGroup.class, DefaultGroup.class);
        dto.setImg(dto.getImg().replace(uploadUrl,""));
        SetResponse setResponse = setRequestService.sendSetRequest(String.valueOf(dto.getId()), dto.toString());
        dto.setBlockchainTxId(setResponse.getData());
        dto.setIsBlock(1);
        certificatesService.update(dto);
        return new Result();
    }


    @DeleteMapping
    @Operation(summary = "删除")
    public Result delete(@RequestBody Long[] ids){
        //效验数据
        AssertUtils.isArrayEmpty(ids, "id");
        certificatesService.delete(ids);
        return new Result();
    }

}
